# define array_tok 257
# define begin_tok 258
# define case_tok 259
# define const_tok 260
# define do_tok 261
# define downto_tok 262
# define else_tok 263
# define end_tok 264
# define file_tok 265
# define for_tok 266
# define function_tok 267
# define goto_tok 268
# define if_tok 269
# define label_tok 270
# define of_tok 271
# define procedure_tok 272
# define program_tok 273
# define record_tok 274
# define repeat_tok 275
# define then_tok 276
# define to_tok 277
# define type_tok 278
# define until_tok 279
# define var_tok 280
# define while_tok 281
# define others_tok 282
# define r_num_tok 283
# define i_num_tok 284
# define string_literal_tok 285
# define single_char_tok 286
# define assign_tok 287
# define two_dots_tok 288
# define undef_id_tok 289
# define var_id_tok 290
# define proc_id_tok 291
# define proc_param_tok 292
# define fun_id_tok 293
# define fun_param_tok 294
# define const_id_tok 295
# define type_id_tok 296
# define hhb0_tok 297
# define hhb1_tok 298
# define field_id_tok 299
# define define_tok 300
# define field_tok 301
# define break_tok 302
# define not_eq_tok 303
# define less_eq_tok 304
# define great_eq_tok 305
# define or_tok 306
# define unary_plus_tok 307
# define unary_minus_tok 308
# define div_tok 309
# define mod_tok 310
# define and_tok 311
# define not_tok 312

# line 20 "web2c.yacc"
#include "web2c.h"

#define YYDEBUG 1

#define	symbol(x)	sym_table[x].id
#define	MAX_ARGS	50

static char fn_return_type[50], for_stack[300], control_var[50],
            relation[3];
static char arg_type[MAX_ARGS][30];
static int last_type = -1, ids_typed;
char my_routine[100];	/* Name of routine being parsed, if any */
static char array_bounds[80], array_offset[80];
static int uses_mem, uses_eqtb, lower_sym, upper_sym;
static FILE *orig_std;
boolean doing_statements = false;
static boolean var_formals = false;
static int param_id_list[MAX_ARGS], ids_paramed=0;

extern char conditional[], temp[], *std_header;
extern int tex, mf, strict_for;
extern FILE *coerce;
extern char coerce_name[];
extern boolean debug;

static long my_labs();
static void compute_array_bounds(), fixup_var_list();
static void do_proc_args(), gen_function_head();
static boolean doreturn();

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 1117 "web2c.yacc"


static void compute_array_bounds()
{
    long lb;
    char tmp[200];

    if (lower_sym == -1) {	/* lower is a constant */
	lb = lower_bound - 1;
	if (lb==0) lb = -1;	/* Treat lower_bound==1 as if lower_bound==0 */
	if (upper_sym == -1)	/* both constants */
	    (void) sprintf(tmp, "[%ld]", upper_bound - lb);
	else {			/* upper a symbol, lower constant */
	    if (lb < 0)
		(void) sprintf(tmp, "[%s + %ld]",
				symbol(upper_sym), (-lb));
	    else
		(void) sprintf(tmp, "[%s - %ld]",
				symbol(upper_sym), lb);
	}
	if (lower_bound < 0 || lower_bound > 1) {
	    if (*array_bounds) {
		fprintf(stderr, "Cannot handle offset in second dimension\n");
		exit(1);
	    }
	    if (lower_bound < 0) {
		(void) sprintf(array_offset, "+%ld", -lower_bound);
	    } else {
		(void) sprintf(array_offset, "-%ld", lower_bound);
	    }
	}
	(void) strcat(array_bounds, tmp);
    }
    else {			/* lower is a symbol */
	if (upper_sym != -1)	/* both are symbols */
	    (void) sprintf(tmp, "[%s - %s + 1]", symbol(upper_sym),
		symbol(lower_sym));
	else {			/* upper constant, lower symbol */
	    (void) sprintf(tmp, "[%ld - %s]", upper_bound + 1,
		symbol(lower_sym));
	}
	if (*array_bounds) {
	    fprintf(stderr, "Cannot handle symbolic offset in second dimension\n");
	    exit(1);
	}
	(void) sprintf(array_offset, "- (int)(%s)", symbol(lower_sym));
	(void) strcat(array_bounds, tmp);
    }
}


/* Kludge around negative lower array bounds.  */

static void
fixup_var_list ()
{
  int i, j;
  char output_string[100], real_symbol[100];

  for (i = 0; var_list[i++] == '!'; )
    {
      for (j = 0; real_symbol[j++] = var_list[i++]; )
        ;
      if (*array_offset)
        {
          (void) fprintf (std, "\n#define %s (%s %s)\n  ",
                          real_symbol, next_temp, array_offset);
          (void) strcpy (real_symbol, next_temp);
          /* Add the temp to the symbol table, so that change files can
             use it later on if necessary.  */
          j = add_to_table (next_temp);
          sym_table[j].typ = var_id_tok;
          find_next_temp ();
        }
      (void) sprintf (output_string, "%s%s%c", real_symbol, array_bounds,
                      var_list[i] == '!' ? ',' : ' ');
      my_output (output_string);
  }
  semicolon ();
}


/* If we're not processing TeX, we return false.  Otherwise,
   return true if the label is "10" and we're not in one of four TeX
   routines where the line labeled "10" isn't the end of the routine.
   Otherwise, return 0.  */
   
static boolean
doreturn (label)
    char *label;
{
    return
      tex
      && STREQ (label, "10")
      && !STREQ (my_routine, "macrocall")
      && !STREQ (my_routine, "hpack")
      && !STREQ (my_routine, "vpackage")
      && !STREQ (my_routine, "trybreak");
}


/* Return the absolute value of a long.  */
static long 
my_labs (x)
  long x;
{
    if (x < 0L) return(-x);
    return(x);
}

static void
do_proc_args ()
{
  fprintf (coerce, "%s %s();\n", fn_return_type, z_id);
}

static void
gen_function_head()
{
    int i;

    if (strcmp(my_routine, z_id)) {
	fprintf(coerce, "#define %s(", my_routine);
	for (i=0; i<ids_paramed; i++) {
	    if (i > 0)
		fprintf(coerce, ", %s", symbol(param_id_list[i]));
	    else
		fprintf(coerce, "%s", symbol(param_id_list[i]));
	}
	fprintf(coerce, ") %s(", z_id);
	for (i=0; i<ids_paramed; i++) {
	    if (i > 0)
		fputs(", ", coerce);
	    fprintf(coerce, "(%s) ", arg_type[i]);
	    fprintf(coerce, "%s(%s)",
		    sym_table[param_id_list[i]].var_formal?"&":"",
		    symbol(param_id_list[i]));
	}
	fprintf(coerce, ")\n");
    }
    std = orig_std;
    my_output(z_id);
    my_output("(");
    for (i=0; i<ids_paramed; i++) {
        if (i > 0) my_output(",");
        my_output(symbol(param_id_list[i]));
    }
    my_output(")");
    indent_line();
    for (i=0; i<ids_paramed; i++) {
        my_output(arg_type[i]);
        my_output(symbol(param_id_list[i]));
        semicolon();
    }
}
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 38,
	289, 30,
	-2, 27,
-1, 53,
	289, 44,
	-2, 41,
-1, 66,
	289, 86,
	290, 86,
	299, 86,
	-2, 83,
-1, 154,
	91, 151,
	46, 151,
	-2, 153,
-1, 208,
	289, 72,
	299, 72,
	-2, 75,
-1, 299,
	289, 72,
	299, 72,
	-2, 75,
-1, 352,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 176,
-1, 353,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 178,
-1, 355,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 182,
-1, 356,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 184,
-1, 357,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 186,
-1, 358,
	61, 0,
	303, 0,
	60, 0,
	62, 0,
	304, 0,
	305, 0,
	-2, 188,
-1, 372,
	277, 258,
	-2, 261,
	};
# define YYNPROD 264
# define YYLAST 542
yytabelem yyact[]={

   307,   294,   379,   232,   365,   128,   129,   306,   301,   363,
   127,   267,   265,   347,   266,   396,   278,   210,    85,    86,
     5,   239,   267,   265,   252,   266,    70,   278,    87,   272,
   269,   273,   368,   267,   265,   182,   266,    49,   278,   267,
   272,   269,   273,    11,   278,    49,   250,     6,    57,    50,
    10,   272,   269,   273,   302,    12,    83,    50,   262,   263,
   261,    13,   346,    14,   303,   111,   110,   114,   115,   290,
   102,   248,    63,   410,   104,   105,    23,   116,   267,   265,
   243,   266,    22,   278,     9,    98,    21,   100,   101,    20,
   267,   265,    19,   266,   344,   278,   272,   269,   273,   267,
   265,    18,   266,     8,   278,   285,   188,   187,   272,   269,
   273,   385,   148,   158,   267,   265,   367,   266,   366,   278,
   161,   142,   147,   162,   190,   169,   172,   183,    43,   160,
    64,   245,   272,   269,   273,   159,   217,   402,   133,    52,
   185,   148,   158,   145,   154,   144,   146,   155,   156,   161,
    37,   147,   162,   406,   329,   367,   138,   366,   160,   397,
    81,    46,   231,   336,   159,    80,   209,    16,   185,    92,
   194,   407,   145,   154,   144,   146,   155,   156,    81,   392,
   388,   326,    25,    80,   299,   138,   185,   375,   185,   142,
   142,   213,   293,   214,    51,   142,   225,   236,   179,   221,
   240,   142,   219,   297,   164,   381,   181,    36,   237,   223,
   207,   108,    24,   233,    67,   180,   255,   256,    95,    33,
   288,    34,    89,    47,    75,    59,    32,   280,   142,    84,
   264,    29,    42,   391,   378,   377,    49,   178,   289,    15,
    58,   107,   211,   340,   206,    31,   203,   390,    50,   201,
    28,   126,   296,   107,   222,   376,   304,   339,   212,    94,
    93,   308,    62,    61,    60,    35,    30,   106,    45,    27,
    17,   205,   270,   274,   275,   277,   204,   186,   268,   271,
   276,    82,   324,   270,   274,   275,   277,    73,    44,   268,
   271,   276,    72,   218,   270,   274,   275,   277,    97,    91,
   268,   271,   276,   109,   165,    39,   268,   271,   276,   413,
   348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
   358,   359,   360,   361,   338,   166,   167,   168,   370,   372,
   142,   163,   369,   142,   249,   373,   118,   124,   380,   270,
   274,   275,   277,   279,    56,   268,   271,   276,   332,   383,
    54,   270,   274,   275,   277,   394,   412,   268,   271,   276,
   284,   341,   333,   277,   342,   393,   268,   271,   276,   337,
   331,   200,   405,   408,   371,   270,   274,   275,   277,   142,
   328,   268,   271,   276,   398,   389,   395,   400,   238,   298,
   198,   258,   399,   184,   142,   327,   404,   403,   401,   380,
   409,   197,   283,   196,    69,   111,   110,   114,   115,   142,
   153,   411,   154,   414,   415,   234,   235,   116,   152,   325,
   259,   151,   364,   387,   249,   362,   323,   195,   224,   228,
   229,   286,   199,   193,   230,   157,   287,   150,   149,   141,
   295,   140,   189,   343,   384,   305,   257,   282,   281,   227,
   322,   321,   320,   319,   318,   317,   316,   315,   314,   313,
   312,   311,   310,   309,   226,   386,   345,   260,   220,   192,
   216,   143,   215,   137,   136,   135,   134,   132,   131,   130,
   191,   139,   335,   247,   122,   103,   334,   246,   121,    79,
   292,   244,   291,   242,   202,   120,    99,   119,    78,    77,
    76,   117,   123,    68,    66,   254,   382,   300,   253,   251,
   208,   177,   176,   175,   174,    48,   173,   171,   170,   125,
    88,    55,    53,   113,   112,    71,    40,    38,    41,    26,
   374,   330,   241,    96,     4,    90,    74,    65,     7,     3,
     2,     1 };
yytabelem yypact[]={

 -1000, -1000,  -253, -1000, -1000,  -186,  -217,  -103,   211,  -188,
  -197,  -200,  -203,  -207,  -213,   -78, -1000, -1000,   210,   191,
   207,   186,   160,   206,  -128, -1000,  -156, -1000, -1000,   247,
 -1000, -1000,   227, -1000,  -258, -1000,  -141, -1000, -1000, -1000,
  -241,   181, -1000, -1000,   205,   204,   203,  -216,  -154, -1000,
 -1000, -1000, -1000, -1000, -1000,  -263, -1000, -1000, -1000,  -156,
 -1000, -1000, -1000,  -258, -1000,  -107, -1000, -1000,  -271, -1000,
 -1000,   161, -1000, -1000,   -89, -1000,   201,   200, -1000, -1000,
  -204,  -219, -1000,   209, -1000, -1000, -1000, -1000,   150,  -218,
 -1000, -1000, -1000, -1000, -1000, -1000,  -103, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -271, -1000,   192,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -146,   -78,   264,
   264,   264,   264,   -59, -1000,   -59, -1000,   129, -1000, -1000,
   219, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,  -180,  -181, -1000, -1000, -1000,  -160, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000,   -93, -1000, -1000,
 -1000, -1000, -1000,  -128,   190, -1000,   187,   218,   213,   185,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,   119,
 -1000,  -105,  -279,   183,   212,  -146,  -117, -1000, -1000,   253,
 -1000,  -146,   163, -1000, -1000,   122,   122,  -146,  -269,   122,
 -1000, -1000,  -149, -1000, -1000, -1000, -1000,  -250, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,   122,   122, -1000, -1000,   127,
   163, -1000, -1000,  -239,  -146,    72,   122, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000,    48,    81,  -182, -1000,
    48,  -141,   179, -1000, -1000, -1000,   -59,   -59,   159, -1000,
 -1000,   125, -1000,  -235,   -59,    48,    48,   122, -1000, -1000,
   122, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,   122,   253,   -80, -1000, -1000,  -122, -1000, -1000,  -149,
 -1000,  -271, -1000, -1000, -1000, -1000,  -108,  -250, -1000, -1000,
   199, -1000, -1000, -1000, -1000,   320, -1000,    36,   -31,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,  -166,    -9, -1000,  -146,   122,   122,  -146,
   -71, -1000,   197, -1000,   176,   175,   -59,   112, -1000, -1000,
  -235, -1000, -1000, -1000,  -173, -1000, -1000, -1000,    -3,    -3,
 -1000, -1000,    57,    57, -1000,    57,    57,    57,    57, -1000,
    -3, -1000,   121, -1000,   189, -1000, -1000, -1000, -1000, -1000,
    48,   -82,    48, -1000, -1000,  -146,  -281, -1000, -1000, -1000,
 -1000,  -112,   -59, -1000,   122, -1000,   122, -1000,  -127, -1000,
  -117,  -166, -1000,  -124,   -91,   109, -1000,   -59, -1000, -1000,
   -20, -1000, -1000, -1000, -1000,  -146, -1000, -1000, -1000, -1000,
 -1000, -1000,   122,   122,    48,    48 };
yytabelem yypgo[]={

     0,   541,   540,   539,   538,   239,   212,   207,   194,   537,
   536,   535,   534,   126,   218,   533,   532,   531,   530,   529,
   528,   232,   527,   305,   526,   525,   213,   524,   523,   522,
   350,   521,   520,   519,     1,   518,   517,   516,   223,   515,
   514,   513,   512,   511,    71,     2,   510,   509,    24,   508,
   507,   506,     8,   505,   504,   214,   503,    56,   502,   229,
   501,    10,   224,   500,   499,   498,   497,   204,   496,   495,
   494,   493,    80,    69,   492,   491,   490,   489,   488,   487,
   192,   486,   485,   484,   483,   482,   481,   480,     5,     6,
   479,   478,   477,   476,   475,   474,   473,     3,   472,     0,
   471,   470,   469,   468,   199,   467,   466,   465,   464,   463,
   462,   461,   460,   459,   458,   457,   456,   455,   454,   453,
   452,   451,   450,   449,   448,   447,   136,   446,   445,     7,
   444,   443,   442,   441,   439,   438,   437,   435,   433,   432,
   431,   428,   427,   426,   425,   423,     9,   422,     4,   421,
   418,   410,   403,   402,   401,   395,   390,   388,   380,   374,
   372,   365,   356,   355,   309 };
yytabelem yyr1[]={

     0,     4,     9,     1,     2,     2,    12,    12,    12,    12,
    12,    12,    12,    12,    12,     3,    15,    16,    17,    14,
     5,    19,     5,    20,    20,    21,     6,     6,    22,    22,
    24,    25,    23,    26,    26,    26,    26,    27,    27,    28,
     7,     7,    29,    29,    31,    32,    33,    30,    34,    34,
    35,    35,    13,    39,    39,    38,    38,    37,    36,    36,
    36,    36,    43,    40,    40,    44,    44,    45,    46,    41,
    47,    47,    49,    51,    48,    48,    50,    50,    52,    52,
    53,    42,     8,     8,    54,    54,    56,    58,    55,    57,
    57,    59,    59,    59,    11,    60,    11,    10,    10,    10,
    62,    62,    63,    66,    65,    69,    65,    67,    70,    67,
    71,    71,    74,    73,    75,    72,    76,    72,    68,    68,
    64,    78,    79,    81,    77,    83,    84,    85,    77,    82,
    82,    80,    18,    87,    86,    61,    61,    88,    88,    90,
    89,    89,    91,    91,    91,    91,    91,    98,    93,   101,
    93,   102,    97,    97,   100,   100,   103,   103,   105,   104,
   104,   104,   104,   106,   107,   106,    99,   109,    99,   110,
    99,   111,    99,   112,    99,   113,    99,   114,    99,   115,
    99,   116,    99,   117,    99,   118,    99,   119,    99,   120,
    99,   121,    99,   122,    99,    99,   108,   108,   108,   124,
   123,   123,   123,   123,   125,   123,   127,   126,   128,   130,
   128,   129,   131,   131,    94,    94,   132,    94,    95,    96,
    92,    92,    92,   133,   133,   135,   135,   139,   140,   137,
   141,   138,   142,   143,   136,   144,   144,   146,   147,   147,
   148,   148,   145,   145,   134,   134,   134,   152,   153,   149,
   154,   155,   150,   156,   158,   160,   151,   157,   161,   162,
   159,   163,   164,   159 };
yytabelem yyr2[]={

     0,     1,     1,    21,     0,     4,     9,     9,     9,    13,
     9,    13,     9,    13,     9,     6,     1,     1,     1,    17,
     0,     1,     9,     2,     6,     3,     0,     5,     2,     4,
     1,     1,    13,     3,     3,     3,     3,     3,     3,     3,
     0,     4,     2,     4,     1,     1,     1,    15,     2,     2,
     3,     2,     6,     0,     2,     5,     3,     3,     3,     2,
     3,     3,     5,    12,    16,     3,     3,     2,     1,     9,
     2,     6,     1,     1,    11,     0,     2,     6,     3,     3,
     1,     9,     0,     4,     2,     4,     1,     1,    13,     2,
     6,     3,     3,     3,     0,     1,    11,     0,     2,     4,
     5,     5,     4,     1,    11,     1,    11,     1,     1,     8,
     2,     6,     1,     9,     1,     4,     1,     6,     2,     2,
     4,     1,     1,     1,    18,     1,     1,     1,    18,     2,
     2,     2,     6,     1,     9,     2,     6,     2,     6,     3,
     3,     3,     2,     2,     2,     2,     3,     1,     8,     1,
     8,     1,     6,     3,     3,     3,     2,     4,     1,     9,
     5,     5,     5,     2,     1,     8,     5,     1,     9,     1,
     9,     1,     9,     1,     9,     1,     9,     1,     9,     1,
     9,     1,     9,     1,     9,     1,     9,     1,     9,     1,
     9,     1,     9,     1,     9,     3,     2,     3,     3,     1,
     9,     2,     2,     3,     1,     6,     1,     9,     2,     1,
     8,     4,     4,     0,     3,     3,     1,     6,     5,     0,
     2,     2,     2,     2,     2,     2,     4,     1,     1,    12,
     1,     6,     1,     1,    15,     2,     6,     7,     2,     6,
     3,     3,     2,     4,     2,     2,     2,     1,     1,    12,
     1,     1,    13,     1,     1,     1,    19,     3,     1,     1,
    11,     1,     1,    11 };
yytabelem yychk[]={

 -1000,    -1,    -2,    -3,   -12,   273,   300,    -4,   289,   301,
   267,   260,   272,   278,   280,    -5,   270,    59,   289,   289,
   289,   289,   289,   289,    -6,   260,   -19,    59,    59,    40,
    59,    59,    40,    59,    61,    59,    -7,   278,   -22,   -23,
   -24,   -20,   -21,   284,    41,    41,   -13,   -38,   -39,   295,
   307,    -8,   280,   -29,   -30,   -31,   -23,   289,    59,    44,
    59,    59,    59,   288,   284,    -9,   -54,   -55,   -56,   -30,
   289,   -25,   -21,   -38,   -10,   -62,   -63,   -64,   -65,   -77,
   272,   267,   -55,   -57,   -59,   289,   290,   299,   -32,    61,
   -11,   -62,   258,    59,    59,   -14,   -15,   -14,   289,   -68,
   291,   292,   289,   -82,   293,   294,    58,    44,    61,   -26,
   284,   283,   -27,   -28,   285,   286,   295,   -60,    -5,   -66,
   -69,   -78,   -83,   -58,   -59,   -33,    59,   -61,   -88,   -89,
   -90,   -91,   -92,   284,   -93,   -94,   -95,   -96,   302,   -86,
  -133,  -134,   -97,  -100,   291,   289,   292,   268,   258,  -135,
  -136,  -149,  -150,  -151,   290,   293,   294,  -137,   259,   281,
   275,   266,   269,    -6,   -67,    40,   -67,   -67,   -67,   -34,
   -35,   -36,   -13,   -37,   -40,   -41,   -42,   -43,   296,   257,
   274,   265,    94,   -34,   264,    59,    58,   287,   287,  -132,
   284,   -87,  -102,  -138,   263,  -142,  -152,  -154,  -156,  -139,
    -7,    59,   -70,    59,    58,    58,    59,    91,   -46,   271,
   296,    59,    46,   -88,   -89,   -98,  -101,  -126,    40,   -61,
  -103,  -104,    91,    46,  -141,   -99,  -108,  -123,   307,   308,
   312,    40,   -97,   -26,   293,   294,   -99,   -61,  -157,   290,
   -99,   -16,   -71,   -72,   -75,   280,   -79,   -84,   -44,   -13,
   296,   -47,   -48,   -49,   -53,   -99,   -99,  -127,   264,  -104,
  -105,   299,   297,   298,   -88,    43,    45,    42,   309,    61,
   303,   310,    60,    62,   304,   305,   311,   306,    47,   271,
   -99,  -124,  -125,  -153,   279,   287,  -140,    -8,    41,    59,
   -73,   -74,   -76,   -80,   -34,   -80,    93,    44,   264,    59,
   -50,   -52,   289,   299,   -34,  -128,  -129,   -99,   -99,  -109,
  -110,  -111,  -112,  -113,  -114,  -115,  -116,  -117,  -118,  -119,
  -120,  -121,  -122,  -143,   -99,  -126,   261,  -155,  -158,   276,
   -17,   -72,   -57,   -73,   -81,   -85,   271,   -44,   -48,    58,
    44,    41,    44,  -131,    58,  -106,    93,    44,   -99,   -99,
   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
   -99,   -99,  -144,  -146,  -147,  -148,   284,   282,    41,   -88,
   -99,  -159,   -99,   -88,   -18,   258,    58,    59,    59,   -45,
   -34,    93,   -51,   -52,  -130,   284,  -107,  -145,    59,   264,
    58,    44,   261,  -161,  -163,   -61,   296,   271,   -34,  -129,
   -99,  -146,   264,   -89,  -148,  -160,   277,   262,   264,   -45,
    93,   -88,  -162,  -164,   -99,   -99 };
yytabelem yydef[]={

     4,    -2,     0,     1,     5,     0,     0,    20,     0,     0,
     0,     0,     0,     0,     0,    26,    21,    15,     0,     0,
     0,     0,     0,     0,    40,    30,     0,     6,     7,     0,
     8,    10,     0,    12,    53,    14,    82,    44,    -2,    28,
     0,     0,    23,    25,     0,     0,     0,     0,     0,    56,
    54,     2,    86,    -2,    42,     0,    29,    31,    22,     0,
     9,    11,    13,    53,    55,    97,    -2,    84,     0,    43,
    45,     0,    24,    52,    94,    98,     0,     0,    16,    16,
     0,     0,    85,     0,    89,    91,    92,    93,     0,     0,
     3,    99,    95,   100,   101,   102,    20,   120,   103,   105,
   118,   119,   121,   125,   129,   130,    87,     0,    46,     0,
    33,    34,    35,    36,    37,    38,    39,   219,    26,   107,
   107,   107,   107,    53,    90,    53,    32,     0,   135,   137,
     0,   140,   141,   139,   142,   143,   144,   145,   146,   220,
   221,   222,     0,     0,   214,   215,   216,     0,   133,   223,
   224,   244,   245,   246,    -2,   154,   155,   225,   232,   247,
   250,   253,   227,    40,     0,   108,     0,     0,     0,     0,
    48,    49,    50,    51,    58,    59,    60,    61,    57,     0,
    68,     0,     0,     0,     0,   219,   219,   147,   149,     0,
   218,   219,     0,   226,   230,     0,     0,   219,     0,     0,
    17,   104,   114,   106,   122,   126,    88,    53,    -2,    80,
    62,    47,    96,   136,   138,     0,     0,   217,   206,     0,
   152,   156,   158,     0,   219,     0,     0,   195,   196,   197,
   198,   199,   201,   202,   203,   204,   248,     0,     0,   257,
   228,    82,     0,   110,   112,   116,    53,    53,     0,    65,
    66,     0,    70,     0,    53,   148,   150,     0,   134,   157,
     0,   160,   161,   162,   231,   167,   169,   171,   173,   175,
   177,   179,   181,   183,   185,   187,   189,   191,   193,   233,
   166,     0,     0,     0,   251,   254,     0,    18,   109,   114,
   115,     0,   112,   123,   131,   127,     0,    53,    69,    -2,
     0,    76,    78,    79,    81,     0,   208,   213,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   205,   219,     0,     0,   219,
     0,   111,     0,   117,     0,     0,    53,     0,    71,    73,
     0,   207,   209,   211,     0,   159,   163,   164,   168,   170,
   172,   174,    -2,    -2,   180,    -2,    -2,    -2,    -2,   190,
   192,   194,     0,   235,     0,   238,   240,   241,   200,   249,
   252,     0,    -2,   229,    19,   219,     0,   124,   128,    63,
    67,     0,    53,    77,     0,   212,     0,   234,     0,   242,
   219,     0,   255,     0,     0,     0,   113,    53,    74,   210,
     0,   236,   243,   237,   239,   219,   259,   262,   132,    64,
   165,   256,     0,     0,   260,   263 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"array_tok",	257,
	"begin_tok",	258,
	"case_tok",	259,
	"const_tok",	260,
	"do_tok",	261,
	"downto_tok",	262,
	"else_tok",	263,
	"end_tok",	264,
	"file_tok",	265,
	"for_tok",	266,
	"function_tok",	267,
	"goto_tok",	268,
	"if_tok",	269,
	"label_tok",	270,
	"of_tok",	271,
	"procedure_tok",	272,
	"program_tok",	273,
	"record_tok",	274,
	"repeat_tok",	275,
	"then_tok",	276,
	"to_tok",	277,
	"type_tok",	278,
	"until_tok",	279,
	"var_tok",	280,
	"while_tok",	281,
	"others_tok",	282,
	"r_num_tok",	283,
	"i_num_tok",	284,
	"string_literal_tok",	285,
	"single_char_tok",	286,
	"assign_tok",	287,
	"two_dots_tok",	288,
	"undef_id_tok",	289,
	"var_id_tok",	290,
	"proc_id_tok",	291,
	"proc_param_tok",	292,
	"fun_id_tok",	293,
	"fun_param_tok",	294,
	"const_id_tok",	295,
	"type_id_tok",	296,
	"hhb0_tok",	297,
	"hhb1_tok",	298,
	"field_id_tok",	299,
	"define_tok",	300,
	"field_tok",	301,
	"break_tok",	302,
	"=",	61,
	"not_eq_tok",	303,
	"<",	60,
	">",	62,
	"less_eq_tok",	304,
	"great_eq_tok",	305,
	"+",	43,
	"-",	45,
	"or_tok",	306,
	"unary_plus_tok",	307,
	"unary_minus_tok",	308,
	"*",	42,
	"/",	47,
	"div_tok",	309,
	"mod_tok",	310,
	"and_tok",	311,
	"not_tok",	312,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
      "PROGRAM : DEFS PROGRAM_HEAD",
      "PROGRAM : DEFS PROGRAM_HEAD LABEL_DEC_PART CONST_DEC_PART TYPE_DEC_PART VAR_DEC_PART",
      "PROGRAM : DEFS PROGRAM_HEAD LABEL_DEC_PART CONST_DEC_PART TYPE_DEC_PART VAR_DEC_PART P_F_DEC_PART BODY",
      "DEFS : /* empty */",
      "DEFS : DEFS DEF",
      "DEF : define_tok field_tok undef_id_tok ';'",
      "DEF : define_tok function_tok undef_id_tok ';'",
      "DEF : define_tok const_tok undef_id_tok ';'",
      "DEF : define_tok function_tok undef_id_tok '(' ')' ';'",
      "DEF : define_tok procedure_tok undef_id_tok ';'",
      "DEF : define_tok procedure_tok undef_id_tok '(' ')' ';'",
      "DEF : define_tok type_tok undef_id_tok ';'",
      "DEF : define_tok type_tok undef_id_tok '=' SUBRANGE_TYPE ';'",
      "DEF : define_tok var_tok undef_id_tok ';'",
      "PROGRAM_HEAD : program_tok undef_id_tok ';'",
      "BLOCK : /* empty */",
      "BLOCK : LABEL_DEC_PART CONST_DEC_PART TYPE_DEC_PART",
      "BLOCK : LABEL_DEC_PART CONST_DEC_PART TYPE_DEC_PART VAR_DEC_PART",
      "BLOCK : LABEL_DEC_PART CONST_DEC_PART TYPE_DEC_PART VAR_DEC_PART STAT_PART",
      "LABEL_DEC_PART : /* empty */",
      "LABEL_DEC_PART : label_tok",
      "LABEL_DEC_PART : label_tok LABEL_LIST ';'",
      "LABEL_LIST : LABEL",
      "LABEL_LIST : LABEL_LIST ',' LABEL",
      "LABEL : i_num_tok",
      "CONST_DEC_PART : /* empty */",
      "CONST_DEC_PART : const_tok CONST_DEC_LIST",
      "CONST_DEC_LIST : CONST_DEC",
      "CONST_DEC_LIST : CONST_DEC_LIST CONST_DEC",
      "CONST_DEC : /* empty */",
      "CONST_DEC : undef_id_tok",
      "CONST_DEC : undef_id_tok '=' CONSTANT ';'",
      "CONSTANT : i_num_tok",
      "CONSTANT : r_num_tok",
      "CONSTANT : STRING",
      "CONSTANT : CONSTANT_ID",
      "STRING : string_literal_tok",
      "STRING : single_char_tok",
      "CONSTANT_ID : const_id_tok",
      "TYPE_DEC_PART : /* empty */",
      "TYPE_DEC_PART : type_tok TYPE_DEF_LIST",
      "TYPE_DEF_LIST : TYPE_DEF",
      "TYPE_DEF_LIST : TYPE_DEF_LIST TYPE_DEF",
      "TYPE_DEF : /* empty */",
      "TYPE_DEF : undef_id_tok",
      "TYPE_DEF : undef_id_tok '='",
      "TYPE_DEF : undef_id_tok '=' TYPE ';'",
      "TYPE : SIMPLE_TYPE",
      "TYPE : STRUCTURED_TYPE",
      "SIMPLE_TYPE : SUBRANGE_TYPE",
      "SIMPLE_TYPE : TYPE_ID",
      "SUBRANGE_TYPE : SUB_CONSTANT two_dots_tok SUB_CONSTANT",
      "POSSIBLE_PLUS : /* empty */",
      "POSSIBLE_PLUS : unary_plus_tok",
      "SUB_CONSTANT : POSSIBLE_PLUS i_num_tok",
      "SUB_CONSTANT : const_id_tok",
      "TYPE_ID : type_id_tok",
      "STRUCTURED_TYPE : ARRAY_TYPE",
      "STRUCTURED_TYPE : RECORD_TYPE",
      "STRUCTURED_TYPE : FILE_TYPE",
      "STRUCTURED_TYPE : POINTER_TYPE",
      "POINTER_TYPE : '^' type_id_tok",
      "ARRAY_TYPE : array_tok '[' INDEX_TYPE ']' of_tok COMPONENT_TYPE",
      "ARRAY_TYPE : array_tok '[' INDEX_TYPE ',' INDEX_TYPE ']' of_tok COMPONENT_TYPE",
      "INDEX_TYPE : SUBRANGE_TYPE",
      "INDEX_TYPE : type_id_tok",
      "COMPONENT_TYPE : TYPE",
      "RECORD_TYPE : record_tok",
      "RECORD_TYPE : record_tok FIELD_LIST end_tok",
      "FIELD_LIST : RECORD_SECTION",
      "FIELD_LIST : FIELD_LIST ';' RECORD_SECTION",
      "RECORD_SECTION : /* empty */",
      "RECORD_SECTION : FIELD_ID_LIST ':'",
      "RECORD_SECTION : FIELD_ID_LIST ':' TYPE",
      "RECORD_SECTION : /* empty */",
      "FIELD_ID_LIST : FIELD_ID",
      "FIELD_ID_LIST : FIELD_ID_LIST ',' FIELD_ID",
      "FIELD_ID : undef_id_tok",
      "FIELD_ID : field_id_tok",
      "FILE_TYPE : file_tok of_tok",
      "FILE_TYPE : file_tok of_tok TYPE",
      "VAR_DEC_PART : /* empty */",
      "VAR_DEC_PART : var_tok VAR_DEC_LIST",
      "VAR_DEC_LIST : VAR_DEC",
      "VAR_DEC_LIST : VAR_DEC_LIST VAR_DEC",
      "VAR_DEC : /* empty */",
      "VAR_DEC : VAR_ID_DEC_LIST ':'",
      "VAR_DEC : VAR_ID_DEC_LIST ':' TYPE ';'",
      "VAR_ID_DEC_LIST : VAR_ID",
      "VAR_ID_DEC_LIST : VAR_ID_DEC_LIST ',' VAR_ID",
      "VAR_ID : undef_id_tok",
      "VAR_ID : var_id_tok",
      "VAR_ID : field_id_tok",
      "BODY : /* empty */",
      "BODY : begin_tok",
      "BODY : begin_tok STAT_LIST end_tok '.'",
      "P_F_DEC_PART : /* empty */",
      "P_F_DEC_PART : P_F_DEC",
      "P_F_DEC_PART : P_F_DEC_PART P_F_DEC",
      "P_F_DEC : PROCEDURE_DEC ';'",
      "P_F_DEC : FUNCTION_DEC ';'",
      "PROCEDURE_DEC : PROCEDURE_HEAD BLOCK",
      "PROCEDURE_HEAD : procedure_tok undef_id_tok",
      "PROCEDURE_HEAD : procedure_tok undef_id_tok PARAM ';'",
      "PROCEDURE_HEAD : procedure_tok DECLARED_PROC",
      "PROCEDURE_HEAD : procedure_tok DECLARED_PROC PARAM ';'",
      "PARAM : /* empty */",
      "PARAM : '('",
      "PARAM : '(' FORM_PAR_SEC_L ')'",
      "FORM_PAR_SEC_L : FORM_PAR_SEC",
      "FORM_PAR_SEC_L : FORM_PAR_SEC_L ';' FORM_PAR_SEC",
      "FORM_PAR_SEC1 : /* empty */",
      "FORM_PAR_SEC1 : VAR_ID_DEC_LIST ':' type_id_tok",
      "FORM_PAR_SEC : /* empty */",
      "FORM_PAR_SEC : FORM_PAR_SEC1",
      "FORM_PAR_SEC : var_tok",
      "FORM_PAR_SEC : var_tok FORM_PAR_SEC1",
      "DECLARED_PROC : proc_id_tok",
      "DECLARED_PROC : proc_param_tok",
      "FUNCTION_DEC : FUNCTION_HEAD BLOCK",
      "FUNCTION_HEAD : function_tok undef_id_tok",
      "FUNCTION_HEAD : function_tok undef_id_tok PARAM ':'",
      "FUNCTION_HEAD : function_tok undef_id_tok PARAM ':' RESULT_TYPE",
      "FUNCTION_HEAD : function_tok undef_id_tok PARAM ':' RESULT_TYPE ';'",
      "FUNCTION_HEAD : function_tok DECLARED_FUN",
      "FUNCTION_HEAD : function_tok DECLARED_FUN PARAM ':'",
      "FUNCTION_HEAD : function_tok DECLARED_FUN PARAM ':' RESULT_TYPE",
      "FUNCTION_HEAD : function_tok DECLARED_FUN PARAM ':' RESULT_TYPE ';'",
      "DECLARED_FUN : fun_id_tok",
      "DECLARED_FUN : fun_param_tok",
      "RESULT_TYPE : TYPE",
      "STAT_PART : begin_tok STAT_LIST end_tok",
      "COMPOUND_STAT : begin_tok",
      "COMPOUND_STAT : begin_tok STAT_LIST end_tok",
      "STAT_LIST : STATEMENT",
      "STAT_LIST : STAT_LIST ';' STATEMENT",
      "STATEMENT : UNLAB_STAT",
      "STATEMENT : S_LABEL ':' UNLAB_STAT",
      "S_LABEL : i_num_tok",
      "UNLAB_STAT : SIMPLE_STAT",
      "UNLAB_STAT : STRUCT_STAT",
      "SIMPLE_STAT : ASSIGN_STAT",
      "SIMPLE_STAT : PROC_STAT",
      "SIMPLE_STAT : GO_TO_STAT",
      "SIMPLE_STAT : EMPTY_STAT",
      "SIMPLE_STAT : break_tok",
      "ASSIGN_STAT : VARIABLE assign_tok",
      "ASSIGN_STAT : VARIABLE assign_tok EXPRESS",
      "ASSIGN_STAT : FUNC_ID_AS assign_tok",
      "ASSIGN_STAT : FUNC_ID_AS assign_tok EXPRESS",
      "VARIABLE : var_id_tok",
      "VARIABLE : var_id_tok VAR_DESIG_LIST",
      "VARIABLE : var_id_tok",
      "FUNC_ID_AS : fun_id_tok",
      "FUNC_ID_AS : fun_param_tok",
      "VAR_DESIG_LIST : VAR_DESIG",
      "VAR_DESIG_LIST : VAR_DESIG_LIST VAR_DESIG",
      "VAR_DESIG : '['",
      "VAR_DESIG : '[' EXPRESS VAR_DESIG1",
      "VAR_DESIG : '.' field_id_tok",
      "VAR_DESIG : '.' hhb0_tok",
      "VAR_DESIG : '.' hhb1_tok",
      "VAR_DESIG1 : ']'",
      "VAR_DESIG1 : ','",
      "VAR_DESIG1 : ',' EXPRESS ']'",
      "EXPRESS : UNARY_OP EXPRESS",
      "EXPRESS : EXPRESS '+'",
      "EXPRESS : EXPRESS '+' EXPRESS",
      "EXPRESS : EXPRESS '-'",
      "EXPRESS : EXPRESS '-' EXPRESS",
      "EXPRESS : EXPRESS '*'",
      "EXPRESS : EXPRESS '*' EXPRESS",
      "EXPRESS : EXPRESS div_tok",
      "EXPRESS : EXPRESS div_tok EXPRESS",
      "EXPRESS : EXPRESS '='",
      "EXPRESS : EXPRESS '=' EXPRESS",
      "EXPRESS : EXPRESS not_eq_tok",
      "EXPRESS : EXPRESS not_eq_tok EXPRESS",
      "EXPRESS : EXPRESS mod_tok",
      "EXPRESS : EXPRESS mod_tok EXPRESS",
      "EXPRESS : EXPRESS '<'",
      "EXPRESS : EXPRESS '<' EXPRESS",
      "EXPRESS : EXPRESS '>'",
      "EXPRESS : EXPRESS '>' EXPRESS",
      "EXPRESS : EXPRESS less_eq_tok",
      "EXPRESS : EXPRESS less_eq_tok EXPRESS",
      "EXPRESS : EXPRESS great_eq_tok",
      "EXPRESS : EXPRESS great_eq_tok EXPRESS",
      "EXPRESS : EXPRESS and_tok",
      "EXPRESS : EXPRESS and_tok EXPRESS",
      "EXPRESS : EXPRESS or_tok",
      "EXPRESS : EXPRESS or_tok EXPRESS",
      "EXPRESS : EXPRESS '/'",
      "EXPRESS : EXPRESS '/' EXPRESS",
      "EXPRESS : FACTOR",
      "UNARY_OP : unary_plus_tok",
      "UNARY_OP : unary_minus_tok",
      "UNARY_OP : not_tok",
      "FACTOR : '('",
      "FACTOR : '(' EXPRESS ')'",
      "FACTOR : VARIABLE",
      "FACTOR : CONSTANT",
      "FACTOR : fun_id_tok",
      "FACTOR : fun_param_tok",
      "FACTOR : fun_param_tok PARAM_LIST",
      "PARAM_LIST : '('",
      "PARAM_LIST : '(' ACTUAL_PARAM_L ')'",
      "ACTUAL_PARAM_L : ACTUAL_PARAM",
      "ACTUAL_PARAM_L : ACTUAL_PARAM_L ','",
      "ACTUAL_PARAM_L : ACTUAL_PARAM_L ',' ACTUAL_PARAM",
      "ACTUAL_PARAM : EXPRESS WIDTH_FIELD",
      "WIDTH_FIELD : ':' i_num_tok",
      "WIDTH_FIELD : /* empty */",
      "PROC_STAT : proc_id_tok",
      "PROC_STAT : undef_id_tok",
      "PROC_STAT : proc_param_tok",
      "PROC_STAT : proc_param_tok PARAM_LIST",
      "GO_TO_STAT : goto_tok i_num_tok",
      "EMPTY_STAT : /* empty */",
      "STRUCT_STAT : COMPOUND_STAT",
      "STRUCT_STAT : CONDIT_STAT",
      "STRUCT_STAT : REPETIT_STAT",
      "CONDIT_STAT : IF_STATEMENT",
      "CONDIT_STAT : CASE_STATEMENT",
      "IF_STATEMENT : BEGIN_IF_STAT",
      "IF_STATEMENT : BEGIN_IF_STAT ELSE_STAT",
      "BEGIN_IF_STAT : if_tok",
      "BEGIN_IF_STAT : if_tok EXPRESS",
      "BEGIN_IF_STAT : if_tok EXPRESS then_tok STATEMENT",
      "ELSE_STAT : else_tok",
      "ELSE_STAT : else_tok STATEMENT",
      "CASE_STATEMENT : case_tok",
      "CASE_STATEMENT : case_tok EXPRESS of_tok",
      "CASE_STATEMENT : case_tok EXPRESS of_tok CASE_EL_LIST END_CASE",
      "CASE_EL_LIST : CASE_ELEMENT",
      "CASE_EL_LIST : CASE_EL_LIST ';' CASE_ELEMENT",
      "CASE_ELEMENT : CASE_LAB_LIST ':' UNLAB_STAT",
      "CASE_LAB_LIST : CASE_LAB",
      "CASE_LAB_LIST : CASE_LAB_LIST ',' CASE_LAB",
      "CASE_LAB : i_num_tok",
      "CASE_LAB : others_tok",
      "END_CASE : end_tok",
      "END_CASE : ';' end_tok",
      "REPETIT_STAT : WHILE_STATEMENT",
      "REPETIT_STAT : REP_STATEMENT",
      "REPETIT_STAT : FOR_STATEMENT",
      "WHILE_STATEMENT : while_tok",
      "WHILE_STATEMENT : while_tok EXPRESS",
      "WHILE_STATEMENT : while_tok EXPRESS do_tok STATEMENT",
      "REP_STATEMENT : repeat_tok",
      "REP_STATEMENT : repeat_tok STAT_LIST until_tok",
      "REP_STATEMENT : repeat_tok STAT_LIST until_tok EXPRESS",
      "FOR_STATEMENT : for_tok",
      "FOR_STATEMENT : for_tok CONTROL_VAR assign_tok",
      "FOR_STATEMENT : for_tok CONTROL_VAR assign_tok FOR_LIST do_tok",
      "FOR_STATEMENT : for_tok CONTROL_VAR assign_tok FOR_LIST do_tok STATEMENT",
      "CONTROL_VAR : var_id_tok",
      "FOR_LIST : EXPRESS",
      "FOR_LIST : EXPRESS to_tok",
      "FOR_LIST : EXPRESS to_tok EXPRESS",
      "FOR_LIST : EXPRESS",
      "FOR_LIST : EXPRESS downto_tok",
      "FOR_LIST : EXPRESS downto_tok EXPRESS",
};
#endif /* YYDEBUG */
/* @(#)27       1.7.1.1  com/cmd/lang/yacc/yaccpar, cmdlang, bos320, 9209320f 2/19/92 16:36:02 */
/*
 * COMPONENT_NAME: (CMDLANG) Language Utilities
 *
 * FUNCTIONS: yyparse
 * ORIGINS: 03
 */
/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#ifdef YYSPLIT
#   define YYERROR      return(-2)
#else
#   define YYERROR      goto yyerrlab
#endif
#ifdef YACC_MSG
#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE
#endif
#include <nl_types.h>
nl_catd catd;
#endif
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#ifndef YACC_MSG
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                yyerror( "syntax error - cannot backup" );\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                catd=catopen("yacc_user.cat",0);\
                yyerror(catgets(catd,1,1,"syntax error - cannot backup" ));\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#endif
#define YYRECOVERING()  (!!yyerrflag)
#ifndef YYDEBUG
#       define YYDEBUG  1       /* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;                    /* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG          (-1000)

#ifdef YYSPLIT
#   define YYSCODE { \
                        extern int (*_yyf[])(); \
                        register int yyret; \
                        if (_yyf[yytmp]) \
                            if ((yyret=(*_yyf[yytmp])()) == -2) \
                                    goto yyerrlab; \
                                else if (yyret>=0) return(yyret); \
                   }
#endif

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];      /* value stack */
int yys[ YYMAXDEPTH ];          /* state stack */

YYSTYPE *yypv;                  /* top of value stack */
YYSTYPE *yypvt;                 /* top of value stack for $vars */
int *yyps;                      /* top of state stack */

int yystate;                    /* current state */
int yytmp;                      /* extra var (lasts between blocks) */

int yynerrs;                    /* number of errors */
int yyerrflag;                  /* error recovery flag */
int yychar;                     /* current input token number */

#ifdef __cplusplus
 #ifdef _CPP_IOSTREAMS
  #include <iostream.h>
  extern void yyerror (char *); /* error message routine -- iostream version */
 #else
  #include <stdio.h>
  extern "C" void yyerror (char *); /* error message routine -- stdio version */
 #endif /* _CPP_IOSTREAMS */
 extern "C" int yylex(void);        /* return the next token */
#endif /* __cplusplus */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#ifdef __cplusplus
extern "C"
#endif /* __cplusplus */
int
yyparse()
{
        /*
        ** Initialize externals - yyparse may be called more than once
        */
        yypv = &yyv[-1];
        yyps = &yys[-1];
        yystate = 0;
        yytmp = 0;
        yynerrs = 0;
        yyerrflag = 0;
        yychar = -1;
#ifdef YACC_MSG
        catd=catopen("yacc_user.cat",0);
#endif
        goto yystack;
        {
                register YYSTYPE *yy_pv;        /* top of value stack */
                register int *yy_ps;            /* top of state stack */
                register int yy_state;          /* current state */
                register int  yy_n;             /* internal state number info */

                /*
                ** get globals into registers.
                ** branch to here only if YYBACKUP was called.
                */
        yynewstate:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;
                goto yy_newstate;

                /*
                ** get globals into registers.
                ** either we just started, or we just finished a reduction
                */
        yystack:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;

                /*
                ** top of for (;;) loop while no reductions done
                */
        yy_stack:
                /*
                ** put a state and value onto the stacks
                */
#if YYDEBUG
                /*
                ** if debugging, look up token value in list of value vs.
                ** name pairs.  0 and negative (-1) are special values.
                ** Note: linear search is used since time is not a real
                ** consideration while debugging.
                */
                if ( yydebug )
                {
                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "State " << yy_state << " token ";
                        if ( yychar == 0 )
                                cout << "end-of-file" << endl;
                        else if ( yychar < 0 )
                                cout << "-none-" << endl;
#else
                        printf( "State %d, token ", yy_state );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << yytoks[yy_i].t_name << endl;
#else
                                printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        }
                }
#endif /* YYDEBUG */
                if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )    /* room on stack? */
                {
#ifndef YACC_MSG
                        yyerror( "yacc stack overflow" );
#else
                        yyerror(catgets(catd,1,2,"yacc stack overflow" ));
#endif
                        YYABORT;
                }
                *yy_ps = yy_state;
                *++yy_pv = yyval;

                /*
                ** we have a new state - find out what to do
                */
        yy_newstate:
                if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
                        goto yydefault;         /* simple state */
#if YYDEBUG
                /*
                ** if debugging, need to mark whether new token grabbed
                */
                yytmp = yychar < 0;
#endif
                if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                        yychar = 0;             /* reached EOF */
#if YYDEBUG
                if ( yydebug && yytmp )
                {
                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "Received token " << endl;
                        if ( yychar == 0 )
                                cout << "end-of-file" << endl;
                        else if ( yychar < 0 )
                                cout << "-none-" << endl;
#else
                        printf( "Received token " );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << yytoks[yy_i].t_name << endl;
#else
                                printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        }
                }
#endif /* YYDEBUG */
                if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
                        goto yydefault;
                if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )  /*valid shift*/
                {
                        yychar = -1;
                        yyval = yylval;
                        yy_state = yy_n;
                        if ( yyerrflag > 0 )
                                yyerrflag--;
                        goto yy_stack;
                }

        yydefault:
                if ( ( yy_n = yydef[ yy_state ] ) == -2 )
                {
#if YYDEBUG
                        yytmp = yychar < 0;
#endif
                        if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                                yychar = 0;             /* reached EOF */
#if YYDEBUG
                        if ( yydebug && yytmp )
                        {
                                register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << "Received token " << endl;
                                if ( yychar == 0 )
                                        cout << "end-of-file" << endl;
                                else if ( yychar < 0 )
                                        cout << "-none-" << endl;
#else
                                printf( "Received token " );
                                if ( yychar == 0 )
                                        printf( "end-of-file\n" );
                                else if ( yychar < 0 )
                                        printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                else
                                {
                                        for ( yy_i = 0;
                                                yytoks[yy_i].t_val >= 0;
                                                yy_i++ )
                                        {
                                                if ( yytoks[yy_i].t_val
                                                        == yychar )
                                                {
                                                        break;
                                                }
                                        }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                        cout << yytoks[yy_i].t_name << endl;
#else
                                        printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                }
                        }
#endif /* YYDEBUG */
                        /*
                        ** look through exception table
                        */
                        {
                                register int *yyxi = yyexca;

                                while ( ( *yyxi != -1 ) ||
                                        ( yyxi[1] != yy_state ) )
                                {
                                        yyxi += 2;
                                }
                                while ( ( *(yyxi += 2) >= 0 ) &&
                                        ( *yyxi != yychar ) )
                                        ;
                                if ( ( yy_n = yyxi[1] ) < 0 )
                                        YYACCEPT;
                        }
                }

                /*
                ** check for syntax error
                */
                if ( yy_n == 0 )        /* have an error */
                {
                        /* no worry about speed here! */
                        switch ( yyerrflag )
                        {
                        case 0:         /* new error */
#ifndef YACC_MSG
                                yyerror( "syntax error" );
#else
                                yyerror(catgets(catd,1,3,"syntax error" ));
#endif
                                goto skip_init;
                        yyerrlab:
                                /*
                                ** get globals into registers.
                                ** we have a user generated syntax type error
                                */
                                yy_pv = yypv;
                                yy_ps = yyps;
                                yy_state = yystate;
                                yynerrs++;
                        skip_init:
                        case 1:
                        case 2:         /* incompletely recovered error */
                                        /* try again... */
                                yyerrflag = 3;
                                /*
                                ** find state where "error" is a legal
                                ** shift action
                                */
                                while ( yy_ps >= yys )
                                {
                                        yy_n = yypact[ *yy_ps ] + YYERRCODE;
                                        if ( yy_n >= 0 && yy_n < YYLAST &&
                                                yychk[yyact[yy_n]] == YYERRCODE)                                        {
                                                /*
                                                ** simulate shift of "error"
                                                */
                                                yy_state = yyact[ yy_n ];
                                                goto yy_stack;
                                        }
                                        /*
                                        ** current state has no shift on
                                        ** "error", pop stack
                                        */
#if YYDEBUG
                                        if ( yydebug )
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                            cout << "Error recovery pops state "
                                                 << (*yy_ps)
                                                 << ", uncovers state "
                                                 << yy_ps[-1] << endl;
#else
#       define _POP_ "Error recovery pops state %d, uncovers state %d\n"
                                                printf( _POP_, *yy_ps,
                                                        yy_ps[-1] );
#       undef _POP_
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
#endif
                                        yy_ps--;
                                        yy_pv--;
                                }
                                /*
                                ** there is no state on stack with "error" as
                                ** a valid shift.  give up.
                                */
                                YYABORT;
                        case 3:         /* no shift yet; eat a token */
#if YYDEBUG
                                /*
                                ** if debugging, look up token in list of
                                ** pairs.  0 and negative shouldn't occur,
                                ** but since timing doesn't matter when
                                ** debugging, it doesn't hurt to leave the
                                ** tests here.
                                */
                                if ( yydebug )
                                {
                                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                        cout << "Error recovery discards ";
                                        if ( yychar == 0 )
                                            cout << "token end-of-file" << endl;
                                        else if ( yychar < 0 )
                                            cout << "token -none-" << endl;
#else
                                        printf( "Error recovery discards " );
                                        if ( yychar == 0 )
                                                printf( "token end-of-file\n" );
                                        else if ( yychar < 0 )
                                                printf( "token -none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                        else
                                        {
                                                for ( yy_i = 0;
                                                        yytoks[yy_i].t_val >= 0;
                                                        yy_i++ )
                                                {
                                                        if ( yytoks[yy_i].t_val
                                                                == yychar )
                                                        {
                                                                break;
                                                        }
                                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                                cout << "token " <<
                                                    yytoks[yy_i].t_name <<
                                                    endl;
#else
                                                printf( "token %s\n",
                                                        yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                        }
                                }
#endif /* YYDEBUG */
                                if ( yychar == 0 )      /* reached EOF. quit */
                                        YYABORT;
                                yychar = -1;
                                goto yy_newstate;
                        }
                }/* end if ( yy_n == 0 ) */
                /*
                ** reduction by production yy_n
                ** put stack tops, etc. so things right after switch
                */
#if YYDEBUG
                /*
                ** if debugging, print the string that is the user's
                ** specification of the reduction which is just about
                ** to be done.
                */
                if ( yydebug )
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "Reduce by (" << yy_n << ") \"" <<
                            yyreds[ yy_n ] << "\"\n";
#else
                        printf( "Reduce by (%d) \"%s\"\n",
                                yy_n, yyreds[ yy_n ] );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
#endif
                yytmp = yy_n;                   /* value to switch over */
                yypvt = yy_pv;                  /* $vars top of value stack */
                /*
                ** Look in goto table for next state
                ** Sorry about using yy_state here as temporary
                ** register variable, but why not, if it works...
                ** If yyr2[ yy_n ] doesn't have the low order bit
                ** set, then there is no action to be done for
                ** this reduction.  So, no saving & unsaving of
                ** registers done.  The only difference between the
                ** code just after the if and the body of the if is
                ** the goto yy_stack in the body.  This way the test
                ** can be made before the choice of what to do is needed.
                */
                {
                        /* length of production doubled with extra bit */
                        register int yy_len = yyr2[ yy_n ];

                        if ( !( yy_len & 01 ) )
                        {
                                yy_len >>= 1;
                                yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                                yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                        *( yy_ps -= yy_len ) + 1;
                                if ( yy_state >= YYLAST ||
                                        yychk[ yy_state =
                                        yyact[ yy_state ] ] != -yy_n )
                                {
                                        yy_state = yyact[ yypgo[ yy_n ] ];
                                }
                                goto yy_stack;
                        }
                        yy_len >>= 1;
                        yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                        yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                *( yy_ps -= yy_len ) + 1;
                        if ( yy_state >= YYLAST ||
                                yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
                        {
                                yy_state = yyact[ yypgo[ yy_n ] ];
                        }
                }
                                        /* save until reenter driver code */
                yystate = yy_state;
                yyps = yy_ps;
                yypv = yy_pv;
        }
        /*
        ** code supplied by user is placed in this switch
        */

                switch(yytmp){

case 1:
# line 58 "web2c.yacc"
{ block_level++;
 	    printf ("#include \"%s\"\n", std_header);
	  } /*NOTREACHED*/ break;
case 2:
# line 63 "web2c.yacc"
{ printf ("\n#include \"%s\"\n", coerce_name); } /*NOTREACHED*/ break;
case 3:
# line 66 "web2c.yacc"
{ YYACCEPT; } /*NOTREACHED*/ break;
case 6:
# line 76 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = field_id_tok;
	    } /*NOTREACHED*/ break;
case 7:
# line 81 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = fun_id_tok;
	    } /*NOTREACHED*/ break;
case 8:
# line 86 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = const_id_tok;
	    } /*NOTREACHED*/ break;
case 9:
# line 91 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = fun_param_tok;
	    } /*NOTREACHED*/ break;
case 10:
# line 96 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = proc_id_tok;
	    } /*NOTREACHED*/ break;
case 11:
# line 101 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = proc_param_tok;
	    } /*NOTREACHED*/ break;
case 12:
# line 106 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = type_id_tok;
	    } /*NOTREACHED*/ break;
case 13:
# line 111 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = type_id_tok;
	      sym_table[ii].val = lower_bound;
	      sym_table[ii].val_sym = lower_sym;
	      sym_table[ii].upper = upper_bound;
	      sym_table[ii].upper_sym = upper_sym;
	    } /*NOTREACHED*/ break;
case 14:
# line 120 "web2c.yacc"
{
	      ii = add_to_table (last_id); 
	      sym_table[ii].typ = var_id_tok;
	    } /*NOTREACHED*/ break;
case 16:
# line 131 "web2c.yacc"
{	if (block_level > 0) my_output("{");
			indent++; block_level++;
		      } /*NOTREACHED*/ break;
case 17:
# line 136 "web2c.yacc"
{if (block_level == 2) {
			    if (strcmp(fn_return_type, "void")) {
			      my_output("register");
			      my_output(fn_return_type);
			      my_output("Result;");
			    }
			    if (tex) {
			      (void) sprintf(safe_string, "%s_regmem",
						my_routine);
			      my_output(safe_string);
			      indent_line();
			    }
			 }
			} /*NOTREACHED*/ break;
case 18:
# line 151 "web2c.yacc"
{if (block_level == 1)
				puts("\n#include \"coerce.h\"");
			 doing_statements = true;
			} /*NOTREACHED*/ break;
case 19:
# line 156 "web2c.yacc"
{if (block_level == 2) {
			    if (strcmp(fn_return_type,"void")) {
			      my_output("return(Result)");
			      semicolon();
			     }
			     if (tex) {
			       if (uses_mem && uses_eqtb)
				(void) fprintf(coerce,
	"#define %s_regmem register memoryword *mem=zmem, *eqtb=zeqtb;\n",
				   my_routine);
			       else if (uses_mem)
				(void) fprintf(coerce,
			"#define %s_regmem register memoryword *mem=zmem;\n",
				   my_routine);
			       else if (uses_eqtb)
				(void) fprintf(coerce,
			"#define %s_regmem register memoryword *eqtb=zeqtb;\n",
				   my_routine);
			       else
				(void) fprintf(coerce,
				   "#define %s_regmem\n",
				   my_routine);
			    }
			    my_routine[0] = '\0';
			 }
			 indent--; block_level--;
			 my_output("}"); new_line();
			 doing_statements = false;
			} /*NOTREACHED*/ break;
case 21:
# line 189 "web2c.yacc"
{ my_output("/*"); } /*NOTREACHED*/ break;
case 22:
# line 191 "web2c.yacc"
{ my_output("*/"); } /*NOTREACHED*/ break;
case 25:
# line 199 "web2c.yacc"
{ my_output(temp); } /*NOTREACHED*/ break;
case 27:
# line 204 "web2c.yacc"
{ indent_line(); } /*NOTREACHED*/ break;
case 30:
# line 212 "web2c.yacc"
{ new_line(); my_output("#define"); } /*NOTREACHED*/ break;
case 31:
# line 214 "web2c.yacc"
{ ii=add_to_table(last_id);
				  sym_table[ii].typ = const_id_tok;
				  my_output(last_id);
				} /*NOTREACHED*/ break;
case 32:
# line 219 "web2c.yacc"
{ sym_table[ii].val=last_i_num;
				  new_line(); } /*NOTREACHED*/ break;
case 33:
# line 224 "web2c.yacc"
{
				  (void) sscanf(temp, "%ld", &last_i_num);
				  if (my_labs((long) last_i_num) > 32767)
				      (void) strcat(temp, "L");
				  my_output(temp);
				  yyval = ex_32;
				} /*NOTREACHED*/ break;
case 34:
# line 232 "web2c.yacc"
{ my_output(temp);
				  yyval = ex_real;
				} /*NOTREACHED*/ break;
case 35:
# line 236 "web2c.yacc"
{ yyval = 0; } /*NOTREACHED*/ break;
case 36:
# line 238 "web2c.yacc"
{ yyval = ex_32; } /*NOTREACHED*/ break;
case 37:
# line 242 "web2c.yacc"
{ int i, j; char s[132];
	  			  j = 1;
				  s[0] = '"';
	  			  for (i=1; yytext[i-1]!=0; i++) {
	  			    if (yytext[i] == '\\' || yytext[i] == '"')
					s[j++]='\\';
	    			    else if (yytext[i] == '\'') i++;
	    			    s[j++] = yytext[i];
				  }
	    			  s[j-1] = '"';
				  s[j] = 0;
				  my_output(s);
				} /*NOTREACHED*/ break;
case 38:
# line 256 "web2c.yacc"
{ char s[5];
				  s[0]='\'';
	    			  if (yytext[1] == '\\' || yytext[1] == '\'') {
	  				s[2] = yytext[1];
					s[1] = '\\';
					s[3] = '\'';
					s[4] = '\0';
				  }
	  			  else {
					s[1] = yytext[1];
					s[2]='\'';
					s[3]='\0';
				  }
	  			  my_output(s);
				} /*NOTREACHED*/ break;
case 39:
# line 274 "web2c.yacc"
{ my_output(last_id); } /*NOTREACHED*/ break;
case 44:
# line 286 "web2c.yacc"
{ my_output("typedef"); } /*NOTREACHED*/ break;
case 45:
# line 288 "web2c.yacc"
{ ii = add_to_table(last_id);
				  sym_table[ii].typ = type_id_tok;
				  (void) strcpy(safe_string, last_id);
				  last_type = ii;
				} /*NOTREACHED*/ break;
case 46:
# line 294 "web2c.yacc"
{
				  array_bounds[0] = 0;
				  array_offset[0] = 0;
				} /*NOTREACHED*/ break;
case 47:
# line 299 "web2c.yacc"
{ if (*array_offset) {
			fprintf(stderr, "Cannot typedef arrays with offsets\n");
					exit(1);
				  }
				  my_output(safe_string);
				  my_output(array_bounds);
				  semicolon();
				  last_type = -1;
				} /*NOTREACHED*/ break;
case 50:
# line 316 "web2c.yacc"
{
              if (last_type >= 0)
                {
                   sym_table[ii].val = lower_bound;
                   sym_table[ii].val_sym = lower_sym;
                   sym_table[ii].upper = upper_bound;
                   sym_table[ii].upper_sym = upper_sym;
                   ii= -1;
                 }
                 
              /* If the bounds on an integral type are known at
                 translation time, select the smallest ANSI C type which
                 can represent it.  We avoid using unsigned char and
                 unsigned short where possible, as ANSI compilers
                 (typically) convert them to int, while traditional
                 compilers convert them to unsigned int.  We also avoid
                 schar if possible, since it also is different on
                 different compilers (see config.h).  */
              if (lower_sym == -1 && upper_sym == -1)
                {
                  if (0 <= lower_bound && upper_bound <= SCHAR_MAX)
                    my_output ("char");
                  else if (SCHAR_MIN <= lower_bound && upper_bound <=SCHAR_MAX)
                    my_output ("schar");
                  else if (0 <= lower_bound && upper_bound <= UCHAR_MAX)
                    my_output ("unsigned char");
                  else if (SHRT_MIN <= lower_bound && upper_bound <= SHRT_MAX)
                    my_output ("short");
                  else if (0 <= lower_bound && upper_bound <= USHRT_MAX)
                    my_output ("unsigned short");
                  else
                    my_output ("integer");
                }
              else
                my_output ("integer");
            } /*NOTREACHED*/ break;
case 55:
# line 364 "web2c.yacc"
{lower_bound = upper_bound;
				 lower_sym = upper_sym;
				 (void) sscanf(temp, "%ld", &upper_bound);
				 upper_sym = -1; /* no sym table entry */
				} /*NOTREACHED*/ break;
case 56:
# line 370 "web2c.yacc"
{ lower_bound = upper_bound;
				  lower_sym = upper_sym;
				  upper_bound = sym_table[l_s].val;
				  upper_sym = l_s;
				} /*NOTREACHED*/ break;
case 57:
# line 378 "web2c.yacc"
{if (last_type >= 0) {
	    sym_table[last_type].var_not_needed = sym_table[l_s].var_not_needed;
	    sym_table[last_type].upper = sym_table[l_s].upper;
	    sym_table[last_type].upper_sym = sym_table[l_s].upper_sym;
	    sym_table[last_type].val = sym_table[l_s].val;
	    sym_table[last_type].val_sym = sym_table[l_s].val_sym;
	 }
	 my_output(last_id); } /*NOTREACHED*/ break;
case 58:
# line 390 "web2c.yacc"
{ if (last_type >= 0)
	        sym_table[last_type].var_not_needed = true;
            } /*NOTREACHED*/ break;
case 60:
# line 395 "web2c.yacc"
{ if (last_type >= 0)
	        sym_table[last_type].var_not_needed = true;
            } /*NOTREACHED*/ break;
case 61:
# line 399 "web2c.yacc"
{ if (last_type >= 0)
	        sym_table[last_type].var_not_needed = true;
            } /*NOTREACHED*/ break;
case 62:
# line 405 "web2c.yacc"
{if (last_type >= 0) {
	    sym_table[last_type].var_not_needed = sym_table[l_s].var_not_needed;
	    sym_table[last_type].upper = sym_table[l_s].upper;
	    sym_table[last_type].upper_sym = sym_table[l_s].upper_sym;
	    sym_table[last_type].val = sym_table[l_s].val;
	    sym_table[last_type].val_sym = sym_table[l_s].val_sym;
	 }
	 my_output(last_id); my_output("*"); } /*NOTREACHED*/ break;
case 65:
# line 421 "web2c.yacc"
{ compute_array_bounds(); } /*NOTREACHED*/ break;
case 66:
# line 423 "web2c.yacc"
{ lower_bound = sym_table[l_s].val;
				  lower_sym = sym_table[l_s].val_sym;
				  upper_bound = sym_table[l_s].upper;
				  upper_sym = sym_table[l_s].upper_sym;
				  compute_array_bounds();
				} /*NOTREACHED*/ break;
case 68:
# line 436 "web2c.yacc"
{ my_output("struct"); my_output("{"); indent++;} /*NOTREACHED*/ break;
case 69:
# line 438 "web2c.yacc"
{ indent--; my_output("}"); semicolon(); } /*NOTREACHED*/ break;
case 72:
# line 446 "web2c.yacc"
{ field_list[0] = 0; } /*NOTREACHED*/ break;
case 73:
# line 448 "web2c.yacc"
{
				  /*array_bounds[0] = 0;
				  array_offset[0] = 0;*/
				} /*NOTREACHED*/ break;
case 74:
# line 453 "web2c.yacc"
{ int i=0, j; char ltemp[80];
				  while(field_list[i++] == '!') {
					j = 0;
					while (field_list[i])
					    ltemp[j++] = field_list[i++];
					i++;
					if (field_list[i] == '!')
						ltemp[j++] = ',';
					ltemp[j] = 0;
					my_output(ltemp);
				  }
				  semicolon();
				} /*NOTREACHED*/ break;
case 78:
# line 474 "web2c.yacc"
{ int i=0, j=0;
				  while (field_list[i] == '!')
					while(field_list[i++]);
				  ii = add_to_table(last_id);
				  sym_table[ii].typ = field_id_tok;
				  field_list[i++] = '!';
				  while (last_id[j])
					field_list[i++] = last_id[j++];
				  field_list[i++] = 0;
				  field_list[i++] = 0;
				} /*NOTREACHED*/ break;
case 79:
# line 486 "web2c.yacc"
{ int i=0, j=0;
				  while (field_list[i] == '!')
					while(field_list[i++]);
				  field_list[i++] = '!';
				  while (last_id[j])
					field_list[i++] = last_id[j++];
				  field_list[i++] = 0;
				  field_list[i++] = 0;
				} /*NOTREACHED*/ break;
case 80:
# line 498 "web2c.yacc"
{ my_output("file_ptr /* of "); } /*NOTREACHED*/ break;
case 81:
# line 500 "web2c.yacc"
{ my_output("*/"); } /*NOTREACHED*/ break;
case 86:
# line 512 "web2c.yacc"
{ var_list[0] = 0;
	      array_bounds[0] = 0;
	      array_offset[0] = 0;
	      var_formals = false;
	      ids_paramed = 0;
	    } /*NOTREACHED*/ break;
case 87:
# line 519 "web2c.yacc"
{
	      array_bounds[0] = 0;	
	      array_offset[0] = 0;
	    } /*NOTREACHED*/ break;
case 88:
# line 524 "web2c.yacc"
{ fixup_var_list(); } /*NOTREACHED*/ break;
case 91:
# line 532 "web2c.yacc"
{ int i=0, j=0;
				  ii = add_to_table(last_id);
				  sym_table[ii].typ = var_id_tok;
				  sym_table[ii].var_formal = var_formals;
				  param_id_list[ids_paramed++] = ii;
	  			  while (var_list[i] == '!')
					while(var_list[i++]);
				  var_list[i++] = '!';
				  while (last_id[j])
					var_list[i++] = last_id[j++];
	  			  var_list[i++] = 0;
				  var_list[i++] = 0;
				} /*NOTREACHED*/ break;
case 92:
# line 546 "web2c.yacc"
{ int i=0, j=0;
				  ii = add_to_table(last_id);
	  			  sym_table[ii].typ = var_id_tok;
				  sym_table[ii].var_formal = var_formals;
				  param_id_list[ids_paramed++] = ii;
	  			  while (var_list[i] == '!')
					while (var_list[i++]);
	  			  var_list[i++] = '!';
				  while (last_id[j])
					var_list[i++] = last_id[j++];
	  			  var_list[i++] = 0;
				  var_list[i++] = 0;
				} /*NOTREACHED*/ break;
case 93:
# line 560 "web2c.yacc"
{ int i=0, j=0;
				  ii = add_to_table(last_id);
	  			  sym_table[ii].typ = var_id_tok;
				  sym_table[ii].var_formal = var_formals;
				  param_id_list[ids_paramed++] = ii;
	  			  while (var_list[i] == '!')
					while(var_list[i++]);
	  			  var_list[i++] = '!';
				  while (last_id[j])
					var_list[i++] = last_id[j++];
				  var_list[i++] = 0;
				  var_list[i++] = 0;
				} /*NOTREACHED*/ break;
case 95:
# line 578 "web2c.yacc"
{ my_output ("void main_body() {");
		  indent++;
		  new_line ();
		} /*NOTREACHED*/ break;
case 96:
# line 583 "web2c.yacc"
{ indent--;
                  my_output ("}");
                  new_line ();
                } /*NOTREACHED*/ break;
case 100:
# line 595 "web2c.yacc"
{ indent_line(); remove_locals(); } /*NOTREACHED*/ break;
case 101:
# line 597 "web2c.yacc"
{ indent_line(); remove_locals(); } /*NOTREACHED*/ break;
case 103:
# line 605 "web2c.yacc"
{ ii = add_to_table(last_id);
	      if (debug)
	        (void) fprintf(stderr, "%3d Procedure %s\n",
                  pf_count++, last_id);
	      sym_table[ii].typ = proc_id_tok;
	      (void) strcpy(my_routine, last_id);
	      uses_eqtb = uses_mem = false;
	      my_output("void");
	      orig_std = std;
	      std = 0;
	    } /*NOTREACHED*/ break;
case 104:
# line 617 "web2c.yacc"
{ (void) strcpy(fn_return_type, "void");
	      do_proc_args();
	      gen_function_head();} /*NOTREACHED*/ break;
case 105:
# line 621 "web2c.yacc"
{ ii = l_s; 
	      if (debug)
	        (void) fprintf(stderr, "%3d Procedure %s\n",
                               pf_count++, last_id);
	      (void) strcpy(my_routine, last_id);
	      my_output("void");
	    } /*NOTREACHED*/ break;
case 106:
# line 629 "web2c.yacc"
{ (void) strcpy(fn_return_type, "void");
	      do_proc_args();
	      gen_function_head();
            } /*NOTREACHED*/ break;
case 107:
# line 637 "web2c.yacc"
{
              (void) strcpy (z_id, last_id);
	      mark ();
	      ids_paramed = 0;
	    } /*NOTREACHED*/ break;
case 108:
# line 643 "web2c.yacc"
{ sprintf (z_id, "z%s", last_id);
	      ids_paramed = 0;
	      if (sym_table[ii].typ == proc_id_tok)
	        sym_table[ii].typ = proc_param_tok;
	      else if (sym_table[ii].typ == fun_id_tok)
	        sym_table[ii].typ = fun_param_tok;
	      mark();
	    } /*NOTREACHED*/ break;
case 112:
# line 659 "web2c.yacc"
{ ids_typed = ids_paramed;} /*NOTREACHED*/ break;
case 113:
# line 661 "web2c.yacc"
{ int i, need_var;
	      i = search_table(last_id);
	      need_var = !sym_table[i].var_not_needed;
	      for (i=ids_typed; i<ids_paramed; i++)
                {
	          (void) strcpy(arg_type[i], last_id);
		  if (need_var && sym_table[param_id_list[i]].var_formal)
	            (void) strcat(arg_type[i], " *");
		  else
                    sym_table[param_id_list[i]].var_formal = false;
	        }
	    } /*NOTREACHED*/ break;
case 114:
# line 675 "web2c.yacc"
{var_formals = 0;} /*NOTREACHED*/ break;
case 116:
# line 676 "web2c.yacc"
{var_formals = 1;} /*NOTREACHED*/ break;
case 121:
# line 687 "web2c.yacc"
{ orig_std = std;
				  std = 0;
				  ii = add_to_table(last_id);
				  if (debug)
				  (void) fprintf(stderr, "%3d Function %s\n",
					pf_count++, last_id);
	  			  sym_table[ii].typ = fun_id_tok;
				  (void) strcpy(my_routine, last_id);
				  uses_eqtb = uses_mem = false;
				} /*NOTREACHED*/ break;
case 122:
# line 698 "web2c.yacc"
{ normal();
				  array_bounds[0] = 0;
				  array_offset[0] = 0;
				} /*NOTREACHED*/ break;
case 123:
# line 703 "web2c.yacc"
{(void) strcpy(fn_return_type, yytext);
			     do_proc_args();
			     gen_function_head();
			    } /*NOTREACHED*/ break;
case 125:
# line 710 "web2c.yacc"
{ orig_std = std;
				  std = 0;
				  ii = l_s;
				  if (debug)
				  (void) fprintf(stderr, "%3d Function %s\n",
					pf_count++, last_id);
				  (void) strcpy(my_routine, last_id);
				  uses_eqtb = uses_mem = false;
				} /*NOTREACHED*/ break;
case 126:
# line 720 "web2c.yacc"
{ normal();
				  array_bounds[0] = 0;
				  array_offset[0] = 0;
				} /*NOTREACHED*/ break;
case 127:
# line 725 "web2c.yacc"
{(void) strcpy(fn_return_type, yytext);
			     do_proc_args();
			     gen_function_head();
			    } /*NOTREACHED*/ break;
case 133:
# line 743 "web2c.yacc"
{my_output("{"); indent++; new_line();} /*NOTREACHED*/ break;
case 134:
# line 745 "web2c.yacc"
{ indent--; my_output("}"); new_line(); } /*NOTREACHED*/ break;
case 139:
# line 758 "web2c.yacc"
{if (!doreturn(temp)) {
				    (void) sprintf(safe_string, "lab%s:",
					temp);
				    my_output(safe_string);
				 }
				} /*NOTREACHED*/ break;
case 140:
# line 767 "web2c.yacc"
{ semicolon(); } /*NOTREACHED*/ break;
case 141:
# line 769 "web2c.yacc"
{ semicolon(); } /*NOTREACHED*/ break;
case 146:
# line 777 "web2c.yacc"
{my_output("break");} /*NOTREACHED*/ break;
case 147:
# line 781 "web2c.yacc"
{ my_output("="); } /*NOTREACHED*/ break;
case 149:
# line 784 "web2c.yacc"
{ my_output("Result ="); } /*NOTREACHED*/ break;
case 151:
# line 789 "web2c.yacc"
{ if (strcmp(last_id, "mem") == 0)
					uses_mem = 1;
				  else if (strcmp(last_id, "eqtb") == 0)
					uses_eqtb = 1;
				  if (sym_table[l_s].var_formal)
					(void) putchar('*');
				  my_output(last_id);
				  yyval = ex_32;
				} /*NOTREACHED*/ break;
case 153:
# line 800 "web2c.yacc"
{ if (sym_table[l_s].var_formal)
					(void) putchar('*');
				  my_output(last_id); yyval = ex_32; } /*NOTREACHED*/ break;
case 154:
# line 806 "web2c.yacc"
{ yyval = ex_32; } /*NOTREACHED*/ break;
case 155:
# line 808 "web2c.yacc"
{ yyval = ex_32; } /*NOTREACHED*/ break;
case 158:
# line 816 "web2c.yacc"
{ my_output("["); } /*NOTREACHED*/ break;
case 159:
# line 818 "web2c.yacc"
{ my_output("]"); } /*NOTREACHED*/ break;
case 160:
# line 820 "web2c.yacc"
{if (tex || mf) {
				   if (strcmp(last_id, "int")==0)
					my_output(".cint");
				   else if (strcmp(last_id, "lh")==0)
					my_output(".v.LH");
				   else if (strcmp(last_id, "rh")==0)
					my_output(".v.RH");
				   else {
				     (void)sprintf(safe_string, ".%s", last_id);
				     my_output(safe_string);
				   }
				 }
				 else {
				    (void) sprintf(safe_string, ".%s", last_id);
				    my_output(safe_string);
				 }
				} /*NOTREACHED*/ break;
case 161:
# line 838 "web2c.yacc"
{ my_output(".hh.b0");} /*NOTREACHED*/ break;
case 162:
# line 840 "web2c.yacc"
{ my_output(".hh.b1");} /*NOTREACHED*/ break;
case 164:
# line 845 "web2c.yacc"
{ my_output("][");} /*NOTREACHED*/ break;
case 166:
# line 850 "web2c.yacc"
{ yyval = yypvt[-0]; } /*NOTREACHED*/ break;
case 167:
# line 851 "web2c.yacc"
{my_output("+");} /*NOTREACHED*/ break;
case 168:
# line 852 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 169:
# line 853 "web2c.yacc"
{my_output("-");} /*NOTREACHED*/ break;
case 170:
# line 854 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 171:
# line 855 "web2c.yacc"
{my_output("*");} /*NOTREACHED*/ break;
case 172:
# line 856 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 173:
# line 857 "web2c.yacc"
{my_output("/");} /*NOTREACHED*/ break;
case 174:
# line 858 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 175:
# line 859 "web2c.yacc"
{my_output("==");} /*NOTREACHED*/ break;
case 176:
# line 860 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 177:
# line 861 "web2c.yacc"
{my_output("!=");} /*NOTREACHED*/ break;
case 178:
# line 862 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 179:
# line 863 "web2c.yacc"
{my_output("%");} /*NOTREACHED*/ break;
case 180:
# line 864 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 181:
# line 865 "web2c.yacc"
{my_output("<");} /*NOTREACHED*/ break;
case 182:
# line 866 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 183:
# line 867 "web2c.yacc"
{my_output(">");} /*NOTREACHED*/ break;
case 184:
# line 868 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 185:
# line 869 "web2c.yacc"
{my_output("<=");} /*NOTREACHED*/ break;
case 186:
# line 870 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 187:
# line 871 "web2c.yacc"
{my_output(">=");} /*NOTREACHED*/ break;
case 188:
# line 872 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 189:
# line 873 "web2c.yacc"
{my_output("&&");} /*NOTREACHED*/ break;
case 190:
# line 874 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 191:
# line 875 "web2c.yacc"
{my_output("||");} /*NOTREACHED*/ break;
case 192:
# line 876 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]);} /*NOTREACHED*/ break;
case 193:
# line 878 "web2c.yacc"
{ my_output("/ ((double)"); } /*NOTREACHED*/ break;
case 194:
# line 880 "web2c.yacc"
{yyval = max(yypvt[-3], yypvt[-0]); my_output(")"); } /*NOTREACHED*/ break;
case 195:
# line 882 "web2c.yacc"
{ yyval = yypvt[-0]; } /*NOTREACHED*/ break;
case 197:
# line 887 "web2c.yacc"
{ my_output("- (integer)"); } /*NOTREACHED*/ break;
case 198:
# line 889 "web2c.yacc"
{ my_output("!"); } /*NOTREACHED*/ break;
case 199:
# line 893 "web2c.yacc"
{ my_output("("); } /*NOTREACHED*/ break;
case 200:
# line 895 "web2c.yacc"
{ my_output(")"); yyval = yypvt[-3]; } /*NOTREACHED*/ break;
case 203:
# line 899 "web2c.yacc"
{ my_output(last_id); my_output("()"); } /*NOTREACHED*/ break;
case 204:
# line 901 "web2c.yacc"
{ my_output(last_id); } /*NOTREACHED*/ break;
case 206:
# line 906 "web2c.yacc"
{ my_output("("); } /*NOTREACHED*/ break;
case 207:
# line 908 "web2c.yacc"
{ my_output(")"); } /*NOTREACHED*/ break;
case 209:
# line 913 "web2c.yacc"
{ my_output(","); } /*NOTREACHED*/ break;
case 214:
# line 926 "web2c.yacc"
{ my_output(last_id); my_output("()"); } /*NOTREACHED*/ break;
case 215:
# line 928 "web2c.yacc"
{ my_output(last_id);
				  ii = add_to_table(last_id);
	  			  sym_table[ii].typ = proc_id_tok;
				  my_output("()");
				} /*NOTREACHED*/ break;
case 216:
# line 934 "web2c.yacc"
{ my_output(last_id); } /*NOTREACHED*/ break;
case 218:
# line 939 "web2c.yacc"
{if (doreturn(temp)) {
				    if (strcmp(fn_return_type,"void"))
					my_output("return(Result)");
				    else
					my_output("return");
				 } else {
				     (void) sprintf(safe_string, "goto lab%s",
					temp);
				     my_output(safe_string);
				 }
				} /*NOTREACHED*/ break;
case 227:
# line 969 "web2c.yacc"
{ my_output("if"); my_output("("); } /*NOTREACHED*/ break;
case 228:
# line 971 "web2c.yacc"
{ my_output(")"); new_line();} /*NOTREACHED*/ break;
case 230:
# line 976 "web2c.yacc"
{ my_output("else"); } /*NOTREACHED*/ break;
case 232:
# line 981 "web2c.yacc"
{ my_output("switch"); my_output("("); } /*NOTREACHED*/ break;
case 233:
# line 983 "web2c.yacc"
{ my_output(")"); indent_line();
				  my_output("{"); indent++;
				} /*NOTREACHED*/ break;
case 234:
# line 987 "web2c.yacc"
{ indent--; my_output("}"); new_line(); } /*NOTREACHED*/ break;
case 237:
# line 995 "web2c.yacc"
{ my_output("break"); semicolon(); } /*NOTREACHED*/ break;
case 240:
# line 1003 "web2c.yacc"
{ my_output("case"); 
				  my_output(temp);
				  my_output(":"); indent_line();
				} /*NOTREACHED*/ break;
case 241:
# line 1008 "web2c.yacc"
{ my_output("default:"); indent_line(); } /*NOTREACHED*/ break;
case 247:
# line 1021 "web2c.yacc"
{ my_output("while");
				  my_output("(");
				} /*NOTREACHED*/ break;
case 248:
# line 1025 "web2c.yacc"
{ my_output(")"); } /*NOTREACHED*/ break;
case 250:
# line 1030 "web2c.yacc"
{ my_output("do"); my_output("{"); indent++; } /*NOTREACHED*/ break;
case 251:
# line 1032 "web2c.yacc"
{ indent--; my_output("}"); 
				  my_output("while"); my_output("( ! (");
				} /*NOTREACHED*/ break;
case 252:
# line 1036 "web2c.yacc"
{ my_output(") )"); } /*NOTREACHED*/ break;
case 253:
# line 1040 "web2c.yacc"
{
				  my_output("{");
				  my_output("register");
				  my_output("integer");
				  if (strict_for)
					my_output("for_begin,");
				  my_output("for_end;");
				 } /*NOTREACHED*/ break;
case 254:
# line 1049 "web2c.yacc"
{ if (strict_for)
					my_output("for_begin");
				  else
					my_output(control_var);
				  my_output("="); } /*NOTREACHED*/ break;
case 255:
# line 1055 "web2c.yacc"
{ my_output("; if (");
				  if (strict_for) my_output("for_begin");
				  else my_output(control_var);
				  my_output(relation);
				  my_output("for_end)");
				  if (strict_for) {
					my_output("{");
					my_output(control_var);
					my_output("=");
					my_output("for_begin");
					semicolon();
				  }
				  my_output("do"); 
				  indent++; 
				  new_line();} /*NOTREACHED*/ break;
case 256:
# line 1071 "web2c.yacc"
{
				  char *top = strrchr (for_stack, '#');
				  indent--;
                                  new_line();
				  my_output("while"); 
				  my_output("("); 
				  my_output(top+1); 
				  my_output(")"); 
				  my_output(";");
				  my_output("}");
				  if (strict_for)
					my_output("}");
				  *top=0;
				  new_line();
				} /*NOTREACHED*/ break;
case 257:
# line 1089 "web2c.yacc"
{(void) strcpy(control_var, last_id); } /*NOTREACHED*/ break;
case 258:
# line 1093 "web2c.yacc"
{ my_output(";"); } /*NOTREACHED*/ break;
case 259:
# line 1095 "web2c.yacc"
{ 
				  (void) strcpy(relation, "<=");
				  my_output("for_end");
				  my_output("="); } /*NOTREACHED*/ break;
case 260:
# line 1100 "web2c.yacc"
{ 
				  (void) sprintf(for_stack + strlen(for_stack),
				    "#%s++ < for_end", control_var);
				} /*NOTREACHED*/ break;
case 261:
# line 1105 "web2c.yacc"
{ my_output(";"); } /*NOTREACHED*/ break;
case 262:
# line 1107 "web2c.yacc"
{
				  (void) strcpy(relation, ">=");
				  my_output("for_end");
				  my_output("="); } /*NOTREACHED*/ break;
case 263:
# line 1112 "web2c.yacc"
{ 
				  (void) sprintf(for_stack + strlen(for_stack),
				    "#%s-- > for_end", control_var);
				} /*NOTREACHED*/ break;
}


        goto yystack;           /* reset registers in driver code */
}
